VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MPPluginDef"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// File: MPPluginDef.cls                                            //
'// Content: Messenger Plus! plugin definitions for Visual Basic 6   //
'// Author: Patchou                                                  //
'//                                                                  //
'// Last Update: 2004/09/13                                          //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////


'//Quick function reference
'//
'//  Initialization function
'//     Initialize()
'//  Uninitialization function
'//     Uninitialize()
'//  Configuration function
'//     Configure()
'//
'//  Inform the users about the features of the plugin
'//     PublishInfo()
'//  Provide new commands in Messenger Plus!
'//     ParseCommand()
'//  Provide new tags in Messenger Plus!
'//     ParseTag()
'//  Allow special actions when a plugin command message is received
'//     ReceiveNotify()
'//
'//  Display toast popups (declared in MPPluginConst)
'//     DisplayToast()
'//  Change the display name of the user (declared in MPPluginConst)
'//     SetNewName()


'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Recognized plugin functions                                      //
'//                                                                  //
'// You must declare the functions in your class exactly as they are //
'// declared in this file. Initialize() is the only mandatory        //
'// function, all the other ones are optional.                       //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////

'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Purpose: Initialization function                                 //
'//                                                                  //
'// Definition:                                                      //
'//   This function is called when Messenger starts and each time a  //
'//   different user signs-in in Messenger.                          //
'//                                                                  //
'// Parameters:                                                      //
'//   * nVersion: plugin support version. This will be used in the   //
'//     future to identify different levels of support. Messenger    //
'//     Plus! 3.20 sets this value to 5.                             //
'//   * sUserEmail: email of the current user in Messenger. If       //
'//     Messenger is not signed-in, this parameter is the email of   //
'//     the last user who signed in. Messenger Plus! uses this value //
'//     to load its own settings.                                    //
'//   * oMessenger: Messenger COM interface. The type of this object //
'//     is "Messenger". For more information, consult the public     //
'//     Messenger API documentation on Microsoft's web site.         //
'//   * return value: if your initialization is successfull, return  //
'//     True to notify Messenger Plus! that the plugin is ready to   //
'//     use.                                                         //
'//                                                                  //
'// Plugin Version Index:                                            //
'//     Messenger Plus! 2.20: 1                                      //
'//     Messenger Plus! 2.21: 2                                      //
'//     Messenger Plus! 2.50: 3                                      //
'//     Messenger Plus! 3.00: 4                                      //
'//     Messenger Plus! 3.20: 5                                      //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////
Public Function Initialize(ByVal nVersion As Long, ByVal sUserEmail As String, ByVal oMessenger As Object) As Boolean
End Function



'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Purpose: Uninitialization function                               //
'//                                                                  //
'// Definition:                                                      //
'//   This function is called when a different user signs-in in      //
'//   Messenger (before Initialize() called for the new user). It is //
'//   not guarenteed that this function will be called when          //
'//   Messenger exits.                                               //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////
Public Function Uninitialize()
End Function



'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Purpose: Configuration/Information function                      //
'//                                                                  //
'// Definition:                                                      //
'//   This function is called when the user clicks on "Configure" in //
'//   the Plugins section of the Preferences of Messenger Plus! 3.00 //
'//   and above. Use it to display a configuration panel or an about //
'//   box.                                                           //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////
Public Function Configure()
End Function




'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Purpose: Inform the users about the features of the plugin       //
'//                                                                  //
'// Definition:                                                      //
'//   These functions are called by Messenger Plus! to get some      //
'//   information about the plugin. You are not forced to implement  //
'//   these functions but doing so will help informing your users    //
'//   about the features you provide (your plugin will be listed in  //
'//   the Plus! menu along with its commands and tags).              //
'//                                                                  //
'// Parameters for GetPublishInfo():                                                      //
'//   * sPluginName: copy the name of your plugin in this buffer.    //
'//     Your plugin will be listed using this name in the Plugins    //
'//     menu. The maximum size for this parameter is 128 characters. //
'//   * nCommandCount: number of commands supported by the plugin.   //
'//     GetPublishCommandInfo() will be called this number of times. //
'//   * nTagCount: number of tags supported by the plugin.           //
'//     GetPublishTagInfo() will be called this number of times.     //
'//   * return value: if you want Messenger Plus! to display all the //
'//     information to the user in the Plugins menu, return True,    //
'//     else, return False.                                          //
'//                                                                  //
'// Parameters for GetPublishCommandInfo():                          //
'//   * nCommandIdx: a number between 1 and nCommandCount            //
'//     representing the index of the command who's info is going to //
'//     be retrieved.                                                //
'//   * sName: name you want to be displayed for the command in the  //
'//     Plugins menu.                                                //
'//   * sValue: command string. Do NOT include "/" at the beginning  //
'//     of the command. Example: "xping".                            //
'//   * sHelp: optional help you want to be displayed when the user  //
'//     selects the command from the Plugins menu. This is useful    //
'//     only when the command accepts arguments.                     //
'//                                                                  //
'// Parameters for GetPublishTagInfo():                              //
'//   * nTagIdx: a number between 1 and nTagCount representing the   //
'//     index of the tag who's info is going to be retrieved.        //
'//   * sName: name you want to be displayed for the tag in the      //
'//     Plugins menu.                                                //
'//   * sValue: tag string. This parameter is the complete tag,      //
'//     including the parenthesis. Remember that it is case          //
'//      sensitive. Example: "(!XSAMP)".                             //
'//                                                                  //
'//  Note that the commands and the tags will be listed in the order //
'//  the functions return them. Also, it is a good practice to add a //
'//  command, with the name of your plugin, that displays a readme,  //
'//  an about box, or any other kind of help.                        //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////
Public Function GetPublishInfo(ByRef sPluginName As String, ByRef nCommandCount As Long, ByRef nTagCount As Long) As Boolean
End Function

Public Function GetPublishCommandInfo(ByVal nCommandIdx As Long, ByRef sName As String, ByRef sValue As String, ByRef sHelp As String)
End Function

Public Function GetPublishTagInfo(ByVal nTagIdx As Long, ByRef sName As String, ByRef sValue As String)
End Function



'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Purpose: Provide new commands in Messenger Plus!                 //
'//                                                                  //
'// Definition:                                                      //
'//   This function is called everytime Messenger Plus! needs its    //
'//   plugins to analyze a command. This happens when the following  //
'//   two conditions are met:                                        //
'//      * the user entered a message and chose to send it           //
'//      * the message begins by "/x". Commands defined by plugins   //
'//        must begin with an "x" (and a command always begins by a  //
'//        "/").                                                     //
'//                                                                  //
'// Parameters:                                                      //
'//   * sCommand: the command entered by the user, including the "/" //
'//     character. Note that commands are not case sensitive.        //
'//   * sCommandArg: all the text that followed the space after the  //
'//     command.                                                     //
'//   * oConversationWnd: Messenger Conversation Window COM          //
'//     interface. The type of this object is                        //
'//     "MessengerConversationWnd". For more information, consult    //
'//     the public Messenger API documentation on Microsoft's web    //
'//     site.                                                        //
'//   * sResult: if you recognize the command passed in sCommand,    //
'//     you must copy the new text to send in this parameter. If     //
'//     you copy an empty string, the text will be ignored and won't //
'//     be sent on the network.
'//   * return value: if you recognized the command and filled the   //
'//     sResult buffer, return True, else, return False.             //
'//                                                                  //
'// Example:                                                         //
'//   The user sends the following text: "/xquote hello you".        //
'//   sCommand = "/xquote"                                           //
'//   sCommandArg = "hello you"                                      //
'//   You could return in sResult this text: "I salute you"          //
'//                                                                  //
'// Advanced: if the plugin version returned by Initialize() is 2 or //
'// above, you can specify more than one message or command in       //
'// sResult. Simply create new lines with # as first character (use  //
'// vbLf to create new lines in your string). Up to 20 actions can   //
'// be specified, each being executed at a 0.5 second interval. A    //
'// different delay can even be entered for each action. After the   //
'// first #, just put a digit between 1 and 9 and another #.         //
'//   Example: sResult = "#First message\n#Second msg\n#5#Third msg" //
'//                                                                  //
'// Important: keep in mind that several plugins can be installed    //
'// and that the user sends a lot of text. If you don't support      //
'// the command passed in parameter, you must return as fast as      //
'// possible and without doing anything else.                        //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////
Public Function ParseCommand(ByVal sCommand As String, ByVal sCommandArg As String, ByVal oConversationWnd As Object, ByRef sResult As String) As Boolean
End Function



'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Purpose: Provide new tags in Messenger Plus!                     //
'//                                                                  //
'// Definition:                                                      //
'//   This function is called everytime Messenger Plus! needs its    //
'//   plugins to analyze a tag. This happens when the following two  //
'//   conditions are met:                                            //
'//      * the user entered a message and chose to send it           //
'//      * the message contains a tag that begins by "x" or "X". A   //
'//        tag is always formatted this way: "(!tag)", is case       //
'//        sensitive and doesn't contain space characters. So plugin //
'//        tags must look like "(!xtag)" (where "tag" can be         //
'//        anything you want).                                       //
'//                                                                  //
'// Parameters:                                                      //
'//   * sTag: the tag entered by the user, containing the            //
'//     parenthesis.                                                 //
'//   * oConversationWnd: Messenger Conversation Window COM          //
'//     interface. The type of this object is                        //
'//     "MessengerConversationWnd". For more information, consult    //
'//     the public Messenger API documentation on Microsoft's web    //
'//     site.                                                        //
'//   * sResult: if you recognize the tag passed in sTag, you        //
'//     must copy the text that will replace the tag in this         //
'//     parameter. Important: the maximum size of this parameter is  //
'//     1100 characters.                                             //
'//   * return value: if you recognized the command and filled the   //
'//     sResult buffer, return True, else, return False.             //
'//                                                                  //
'// Example:                                                         //
'//   The user sends the following text: "my horoscope: (!XH)".      //
'//   sTag = "(!XH)"                                                 //
'//   You could return in sResult this text: "you'll meet somone     //
'//      today" and text sent on the network will be "my horoscope:  //
'//      you'll meet someone today".                                 //
'//                                                                  //
'// Important: keep in mind that several plugins can be installed    //
'// and that the user sends a lot of text. If you don't support      //
'// the tag passed in parameter, you must return as fast as          //
'// possible and without doing anything else.                        //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////
Public Function ParseTag(ByVal sTag As String, ByVal oConversationWnd As Object, ByRef sResult As String) As Boolean
End Function



'//////////////////////////////////////////////////////////////////////
'//                                                                  //
'// Purpose: Allow special actions when a plugin text is received    //
'//                                                                  //
'// Definition:                                                      //
'//   This function is called everytime Messenger Plus! detects a    //
'//   plugin text ID in a message received from a user. This ID is   //
'//   generally placed at the beginning of a text by a plugin        //
'//   command to perform an action on the destination computers.     //
'//   This can be used, for example, to play a sound. See the        //
'//   control characters section for more information.               //
'//                                                                  //
'// Parameters:                                                      //
'//   * sNotifyCode: this 5 character string is the notify code that //
'//     was sent next to the plugin ID control character. Use it to  //
'//     identify what action to perform.                             //
'//   * sText: the rest of the received message. You can use it to   //
'//     get more information about the action you want to perform.   //
'//     However, you MUST NOT use this parameter to determine if an  //
'//     action is supported by your plugin. Use sNotifyCode instead. //
'//   * sContactName: friendly name of the contact who sent this     //
'//     text.                                                        //
'//   * oConversationWnd: Messenger Conversation Window COM          //
'//     interface. The type of this object is                        //
'//     "MessengerConversationWnd". For more information, consult    //
'//     the public Messenger API documentation on Microsoft's web    //
'//     site.                                                        //
'//   * sTextToSend: this parameter is optional. You can use it if   //
'//     you want to ask Messenger Plus! to send a new message after  //
'//     this one has been displayed. This WON'T modify the message   //
'//     associated with the notify code, this will simply send a new //
'//     one.                                                         //
'//   * return value: if you recognized the notify code return True, //
'//     else, return False.                                          //
'//                                                                  //
'// Advanced: if the plugin version returned by Initialize() is 2 or //
'// above, you can specify more than one message or command in       //
'// sTextToSend. Simply create new lines with # as first character   //
'// (use vbLf to create new lines in your string). Up to 20 actions  //
'// can be specified, each being executed at a 0.5 second interval.  //
'// A different delay can even be entered for each action. After the //
'// first #, just put a digit between 1 and 9 and another #.         //
'//   Example: sTextToSend = "#First message\n#5#Second message"     //
'//                                                                  //
'// Important: keep in mind that several plugins can be installed    //
'// and that a lot of text is received. If you don't support the     //
'// notify code passed in parameter, you must return as fast as      //
'// possible and without doing anything else.                        //
'//                                                                  //
'//////////////////////////////////////////////////////////////////////
Public Function ReceiveNotify(ByVal sNotifyCode As String, ByVal sText As String, ByVal sContactName As String, ByVal oConversationWnd As Object, ByRef sTextToSend As String) As Boolean
End Function

